"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getBootstrapStackName = exports.getApiStackName = exports.getWebStackName = exports.getInfStackName = exports.getBaseStackName = exports.getEventBusSnsTopicArn = exports.getCFExportNameWebsocketApiIdFromConfig = exports.getCFExportNameDistributionIdArnFromConfig = exports.getCFExportNameSnsTopicArnFromConfig = exports.getCFExportNameApiKeyIdFromConfig = exports.getCFExportNameUserPoolClientIdFromConfig = exports.getCFExportNameCachePolicyIdFromConfig = exports.getCFExportNameUserPoolIdFromConfig = exports.getKvsDynamoTableNameFromConfig = exports.getQpqRuntimeResourceNameFromConfig = exports.getQpqRuntimeResourceName = exports.getConfigRuntimeResourceNameFromConfigWithServiceOverride = exports.getConfigRuntimeBootstrapResourceNameFromConfig = exports.resolveConfigRuntimeResourceNameFromConfig = exports.getConfigRuntimeResourceNameFromConfig = exports.getConfigRuntimeBootstrapResourceName = exports.getConfigRuntimeResourceName = exports.getGlobalQpqRuntimeResourceName = exports.getGlobalConfigRuntimeResourceName = void 0;
const quidproquo_config_aws_1 = require("quidproquo-config-aws");
const quidproquo_core_1 = require("quidproquo-core");
const quidproquo_webserver_1 = require("quidproquo-webserver");
const getGlobalConfigRuntimeResourceName = (resourceName, application, environment, feature) => {
    const baseName = `${resourceName}-${application}-${environment}`;
    if (feature) {
        return `${baseName}-${feature}`;
    }
    return baseName;
};
exports.getGlobalConfigRuntimeResourceName = getGlobalConfigRuntimeResourceName;
const getGlobalQpqRuntimeResourceName = (resourceName, application, environment, feature, resourceType = '') => {
    const name = (0, exports.getGlobalConfigRuntimeResourceName)(resourceName, application, environment, feature);
    return `${name}-qpq${resourceType}`;
};
exports.getGlobalQpqRuntimeResourceName = getGlobalQpqRuntimeResourceName;
const getConfigRuntimeResourceName = (resourceName, application, service, environment, feature) => {
    const baseName = `${resourceName}-${application}-${service}-${environment}`;
    if (feature) {
        return `${baseName}-${feature}`;
    }
    return baseName;
};
exports.getConfigRuntimeResourceName = getConfigRuntimeResourceName;
const getConfigRuntimeBootstrapResourceName = (resourceName, application, environment, feature) => {
    const baseName = `${resourceName}-${application}-${environment}`;
    if (feature) {
        return `${baseName}-${feature}`;
    }
    return baseName;
};
exports.getConfigRuntimeBootstrapResourceName = getConfigRuntimeBootstrapResourceName;
const getConfigRuntimeResourceNameFromConfig = (resourceName, qpqConfig) => {
    const application = quidproquo_core_1.qpqCoreUtils.getApplicationName(qpqConfig);
    const service = quidproquo_core_1.qpqCoreUtils.getApplicationModuleName(qpqConfig);
    const environment = quidproquo_core_1.qpqCoreUtils.getApplicationModuleEnvironment(qpqConfig);
    const feature = quidproquo_core_1.qpqCoreUtils.getApplicationModuleFeature(qpqConfig);
    return (0, exports.getConfigRuntimeResourceName)(resourceName, application, service, environment, feature);
};
exports.getConfigRuntimeResourceNameFromConfig = getConfigRuntimeResourceNameFromConfig;
const resolveConfigRuntimeResourceNameFromConfig = (resourceName, qpqConfig, owner) => {
    const application = (owner === null || owner === void 0 ? void 0 : owner.application) || quidproquo_core_1.qpqCoreUtils.getApplicationName(qpqConfig);
    const service = (owner === null || owner === void 0 ? void 0 : owner.module) || quidproquo_core_1.qpqCoreUtils.getApplicationModuleName(qpqConfig);
    const environment = (owner === null || owner === void 0 ? void 0 : owner.environment) || quidproquo_core_1.qpqCoreUtils.getApplicationModuleEnvironment(qpqConfig);
    const feature = (owner === null || owner === void 0 ? void 0 : owner.feature) || quidproquo_core_1.qpqCoreUtils.getApplicationModuleFeature(qpqConfig);
    return (0, exports.getConfigRuntimeResourceName)(resourceName, application, service, environment, feature);
};
exports.resolveConfigRuntimeResourceNameFromConfig = resolveConfigRuntimeResourceNameFromConfig;
const getConfigRuntimeBootstrapResourceNameFromConfig = (resourceName, qpqConfig) => {
    const application = quidproquo_core_1.qpqCoreUtils.getApplicationName(qpqConfig);
    const environment = quidproquo_core_1.qpqCoreUtils.getApplicationModuleEnvironment(qpqConfig);
    const feature = quidproquo_core_1.qpqCoreUtils.getApplicationModuleFeature(qpqConfig);
    return (0, exports.getConfigRuntimeBootstrapResourceName)(resourceName, application, environment, feature);
};
exports.getConfigRuntimeBootstrapResourceNameFromConfig = getConfigRuntimeBootstrapResourceNameFromConfig;
const getConfigRuntimeResourceNameFromConfigWithServiceOverride = (resourceName, qpqConfig, serviceOverride) => {
    const application = quidproquo_core_1.qpqCoreUtils.getApplicationName(qpqConfig);
    const service = serviceOverride || quidproquo_core_1.qpqCoreUtils.getApplicationModuleName(qpqConfig);
    const environment = quidproquo_core_1.qpqCoreUtils.getApplicationModuleEnvironment(qpqConfig);
    const feature = quidproquo_core_1.qpqCoreUtils.getApplicationModuleFeature(qpqConfig);
    return (0, exports.getConfigRuntimeResourceName)(resourceName, application, service, environment, feature);
};
exports.getConfigRuntimeResourceNameFromConfigWithServiceOverride = getConfigRuntimeResourceNameFromConfigWithServiceOverride;
const getQpqRuntimeResourceName = (resourceName, application, service, environment, feature, resourceType = '') => {
    const name = (0, exports.getConfigRuntimeResourceName)(resourceName, application, service, environment, feature);
    return `${name}-qpq${resourceType}`;
};
exports.getQpqRuntimeResourceName = getQpqRuntimeResourceName;
const getQpqRuntimeResourceNameFromConfig = (resourceName, qpqConfig, resourceType = '') => {
    const crossServiceResourceName = quidproquo_core_1.qpqCoreUtils.resolveCrossServiceResourceName(resourceName);
    const application = quidproquo_core_1.qpqCoreUtils.getApplicationName(qpqConfig);
    const service = crossServiceResourceName.service || quidproquo_core_1.qpqCoreUtils.getApplicationModuleName(qpqConfig);
    const environment = quidproquo_core_1.qpqCoreUtils.getApplicationModuleEnvironment(qpqConfig);
    const feature = quidproquo_core_1.qpqCoreUtils.getApplicationModuleFeature(qpqConfig);
    return (0, exports.getQpqRuntimeResourceName)(crossServiceResourceName.name, application, service, environment, feature, resourceType);
};
exports.getQpqRuntimeResourceNameFromConfig = getQpqRuntimeResourceNameFromConfig;
const getKvsDynamoTableNameFromConfig = (resourceName, qpqConfig, resourceType = '') => {
    var _a;
    const tableNameOverride = quidproquo_config_aws_1.qpqConfigAwsUtils.getDynamoTableNameOverrride(resourceName, qpqConfig);
    if (tableNameOverride) {
        return tableNameOverride;
    }
    const storeConfig = quidproquo_core_1.qpqCoreUtils.getKeyValueStoreByName(qpqConfig, resourceName);
    const application = quidproquo_core_1.qpqCoreUtils.getApplicationName(qpqConfig);
    const service = ((_a = storeConfig === null || storeConfig === void 0 ? void 0 : storeConfig.owner) === null || _a === void 0 ? void 0 : _a.module) || quidproquo_core_1.qpqCoreUtils.getApplicationModuleName(qpqConfig);
    const environment = quidproquo_core_1.qpqCoreUtils.getApplicationModuleEnvironment(qpqConfig);
    const feature = quidproquo_core_1.qpqCoreUtils.getApplicationModuleFeature(qpqConfig);
    return (0, exports.getQpqRuntimeResourceName)(resourceName, application, service, environment, feature, resourceType);
};
exports.getKvsDynamoTableNameFromConfig = getKvsDynamoTableNameFromConfig;
const getCFExportNameUserPoolIdFromConfig = (userDirectoryName, qpqConfig) => {
    var _a, _b, _c, _d, _e;
    const userDirectoryConfig = quidproquo_core_1.qpqCoreUtils.getUserDirectoryByName(userDirectoryName, qpqConfig);
    const application = ((_a = userDirectoryConfig.owner) === null || _a === void 0 ? void 0 : _a.application) || quidproquo_core_1.qpqCoreUtils.getApplicationName(qpqConfig);
    const service = ((_b = userDirectoryConfig.owner) === null || _b === void 0 ? void 0 : _b.module) || quidproquo_core_1.qpqCoreUtils.getApplicationModuleName(qpqConfig);
    const environment = ((_c = userDirectoryConfig.owner) === null || _c === void 0 ? void 0 : _c.environment) || quidproquo_core_1.qpqCoreUtils.getApplicationModuleEnvironment(qpqConfig);
    const feature = ((_d = userDirectoryConfig.owner) === null || _d === void 0 ? void 0 : _d.feature) || quidproquo_core_1.qpqCoreUtils.getApplicationModuleFeature(qpqConfig);
    const resourceName = ((_e = userDirectoryConfig.owner) === null || _e === void 0 ? void 0 : _e.resourceNameOverride) || userDirectoryName;
    return (0, exports.getQpqRuntimeResourceName)(resourceName, application, service, environment, feature, 'user-pool-id-export');
};
exports.getCFExportNameUserPoolIdFromConfig = getCFExportNameUserPoolIdFromConfig;
const getCFExportNameCachePolicyIdFromConfig = (cacheConfigName, qpqConfig, serviceOverride, applicationOverride) => {
    const application = applicationOverride || quidproquo_core_1.qpqCoreUtils.getApplicationName(qpqConfig);
    const service = serviceOverride || quidproquo_core_1.qpqCoreUtils.getApplicationModuleName(qpqConfig);
    const environment = quidproquo_core_1.qpqCoreUtils.getApplicationModuleEnvironment(qpqConfig);
    const feature = quidproquo_core_1.qpqCoreUtils.getApplicationModuleFeature(qpqConfig);
    return (0, exports.getQpqRuntimeResourceName)(cacheConfigName, application, service, environment, feature, 'cache-policy-name-export');
};
exports.getCFExportNameCachePolicyIdFromConfig = getCFExportNameCachePolicyIdFromConfig;
const getCFExportNameUserPoolClientIdFromConfig = (userDirectoryName, qpqConfig) => {
    var _a, _b, _c, _d, _e;
    const userDirectoryConfig = quidproquo_core_1.qpqCoreUtils.getUserDirectoryByName(userDirectoryName, qpqConfig);
    const application = ((_a = userDirectoryConfig.owner) === null || _a === void 0 ? void 0 : _a.application) || quidproquo_core_1.qpqCoreUtils.getApplicationName(qpqConfig);
    const service = ((_b = userDirectoryConfig.owner) === null || _b === void 0 ? void 0 : _b.module) || quidproquo_core_1.qpqCoreUtils.getApplicationModuleName(qpqConfig);
    const environment = ((_c = userDirectoryConfig.owner) === null || _c === void 0 ? void 0 : _c.environment) || quidproquo_core_1.qpqCoreUtils.getApplicationModuleEnvironment(qpqConfig);
    const feature = ((_d = userDirectoryConfig.owner) === null || _d === void 0 ? void 0 : _d.feature) || quidproquo_core_1.qpqCoreUtils.getApplicationModuleFeature(qpqConfig);
    const resourceName = ((_e = userDirectoryConfig.owner) === null || _e === void 0 ? void 0 : _e.resourceNameOverride) || userDirectoryName;
    return (0, exports.getQpqRuntimeResourceName)(resourceName, application, service, environment, feature, 'user-pool-client-id-export');
};
exports.getCFExportNameUserPoolClientIdFromConfig = getCFExportNameUserPoolClientIdFromConfig;
const getCFExportNameApiKeyIdFromConfig = (apiKeyName, qpqConfig, serviceOverride, applicationOverride) => {
    const application = applicationOverride || quidproquo_core_1.qpqCoreUtils.getApplicationName(qpqConfig);
    const service = serviceOverride || quidproquo_core_1.qpqCoreUtils.getApplicationModuleName(qpqConfig);
    const environment = quidproquo_core_1.qpqCoreUtils.getApplicationModuleEnvironment(qpqConfig);
    const feature = quidproquo_core_1.qpqCoreUtils.getApplicationModuleFeature(qpqConfig);
    return (0, exports.getQpqRuntimeResourceName)(apiKeyName, application, service, environment, feature, 'api-key-id-export');
};
exports.getCFExportNameApiKeyIdFromConfig = getCFExportNameApiKeyIdFromConfig;
const getCFExportNameSnsTopicArnFromConfig = (eventBusName, qpqConfig, applicationOverride) => {
    const application = applicationOverride || quidproquo_core_1.qpqCoreUtils.getApplicationName(qpqConfig);
    const environment = quidproquo_core_1.qpqCoreUtils.getApplicationModuleEnvironment(qpqConfig);
    const feature = quidproquo_core_1.qpqCoreUtils.getApplicationModuleFeature(qpqConfig);
    return (0, exports.getGlobalQpqRuntimeResourceName)(eventBusName, application, environment, feature, 'sns-topic-arn-export');
};
exports.getCFExportNameSnsTopicArnFromConfig = getCFExportNameSnsTopicArnFromConfig;
const getCFExportNameDistributionIdArnFromConfig = (webEntryName, qpqConfig, serviceOverride, applicationOverride) => {
    const application = applicationOverride || quidproquo_core_1.qpqCoreUtils.getApplicationName(qpqConfig);
    const service = serviceOverride || quidproquo_core_1.qpqCoreUtils.getApplicationModuleName(qpqConfig);
    const environment = quidproquo_core_1.qpqCoreUtils.getApplicationModuleEnvironment(qpqConfig);
    const feature = quidproquo_core_1.qpqCoreUtils.getApplicationModuleFeature(qpqConfig);
    return (0, exports.getQpqRuntimeResourceName)(webEntryName, application, service, environment, feature, 'distribution-id-export');
};
exports.getCFExportNameDistributionIdArnFromConfig = getCFExportNameDistributionIdArnFromConfig;
const getCFExportNameWebsocketApiIdFromConfig = (websocketApiName, qpqConfig) => {
    var _a, _b, _c, _d, _e;
    const websocketApiConfig = quidproquo_webserver_1.qpqWebServerUtils.getWebsocketEntryByApiName(websocketApiName, qpqConfig);
    const application = ((_a = websocketApiConfig.owner) === null || _a === void 0 ? void 0 : _a.application) || quidproquo_core_1.qpqCoreUtils.getApplicationName(qpqConfig);
    const service = ((_b = websocketApiConfig.owner) === null || _b === void 0 ? void 0 : _b.module) || quidproquo_core_1.qpqCoreUtils.getApplicationModuleName(qpqConfig);
    const environment = ((_c = websocketApiConfig.owner) === null || _c === void 0 ? void 0 : _c.environment) || quidproquo_core_1.qpqCoreUtils.getApplicationModuleEnvironment(qpqConfig);
    const feature = ((_d = websocketApiConfig.owner) === null || _d === void 0 ? void 0 : _d.feature) || quidproquo_core_1.qpqCoreUtils.getApplicationModuleFeature(qpqConfig);
    const resourceName = ((_e = websocketApiConfig.owner) === null || _e === void 0 ? void 0 : _e.resourceNameOverride) || websocketApiName;
    return (0, exports.getQpqRuntimeResourceName)(resourceName, application, service, environment, feature, 'websocket-api-id-export');
};
exports.getCFExportNameWebsocketApiIdFromConfig = getCFExportNameWebsocketApiIdFromConfig;
const getEventBusSnsTopicArn = (eventBusName, qpqConfig, module, environment, application, feature) => {
    const topicName = (0, exports.getConfigRuntimeResourceName)(eventBusName, application, module, environment, feature);
    const accountInfo = (0, quidproquo_config_aws_1.getAwsServiceAccountInfoByDeploymentInfo)(qpqConfig, module, environment, feature, application);
    const awsAccountId = accountInfo.awsAccountId;
    const region = accountInfo.awsRegion;
    return `arn:aws:sns:${region}:${awsAccountId}:${topicName}`;
};
exports.getEventBusSnsTopicArn = getEventBusSnsTopicArn;
const getBaseStackName = (qpqConfig) => {
    const appName = quidproquo_core_1.qpqCoreUtils.getApplicationName(qpqConfig);
    const moduleName = quidproquo_core_1.qpqCoreUtils.getApplicationModuleName(qpqConfig);
    const environment = quidproquo_core_1.qpqCoreUtils.getApplicationModuleEnvironment(qpqConfig);
    const feature = quidproquo_core_1.qpqCoreUtils.getApplicationModuleFeature(qpqConfig);
    const baseName = `${appName}-${moduleName}-${environment}`;
    if (feature) {
        return `${baseName}-${feature}`;
    }
    return baseName;
};
exports.getBaseStackName = getBaseStackName;
const getInfStackName = (qpqConfig) => {
    return `${(0, exports.getBaseStackName)(qpqConfig)}-inf`;
};
exports.getInfStackName = getInfStackName;
const getWebStackName = (qpqConfig) => {
    return `${(0, exports.getBaseStackName)(qpqConfig)}-web`;
};
exports.getWebStackName = getWebStackName;
const getApiStackName = (qpqConfig) => {
    return `${(0, exports.getBaseStackName)(qpqConfig)}-api`;
};
exports.getApiStackName = getApiStackName;
const getBootstrapStackName = (qpqConfig) => {
    const appName = quidproquo_core_1.qpqCoreUtils.getApplicationName(qpqConfig);
    const environment = quidproquo_core_1.qpqCoreUtils.getApplicationModuleEnvironment(qpqConfig);
    const feature = quidproquo_core_1.qpqCoreUtils.getApplicationModuleFeature(qpqConfig);
    const baseName = `${appName}-${environment}`;
    if (feature) {
        return `${baseName}-${feature}-bs`;
    }
    return `${baseName}-bs`;
};
exports.getBootstrapStackName = getBootstrapStackName;
