"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getConfigGetParametersActionProcessor = void 0;
const quidproquo_config_aws_1 = require("quidproquo-config-aws");
const quidproquo_core_1 = require("quidproquo-core");
const getParameters_1 = require("../../../logic/parametersManager/getParameters");
const qpqAwsLambdaRuntimeConfigUtils_1 = require("../../../runtimeConfig/qpqAwsLambdaRuntimeConfigUtils");
const getProcessConfigGetParameters = (qpqConfig) => {
    return ({ parameterNames }) => __awaiter(void 0, void 0, void 0, function* () {
        const awsParameterKeys = parameterNames.map((pn) => (0, qpqAwsLambdaRuntimeConfigUtils_1.resolveParameterKey)(pn, qpqConfig));
        try {
            const parameterValues = yield (0, getParameters_1.getParameters)(awsParameterKeys, quidproquo_config_aws_1.qpqConfigAwsUtils.getApplicationModuleDeployRegion(qpqConfig));
            return (0, quidproquo_core_1.actionResult)(parameterValues);
        }
        catch (error) {
            return (0, quidproquo_core_1.actionResultErrorFromCaughtError)(error, {
                ThrottlingException: () => (0, quidproquo_core_1.actionResultError)(quidproquo_core_1.ConfigGetParametersErrorTypeEnum.Throttling, 'Throttling: Rate exceeded'),
            });
        }
    });
};
const getConfigGetParametersActionProcessor = (qpqConfig) => __awaiter(void 0, void 0, void 0, function* () {
    return ({
        [quidproquo_core_1.ConfigActionType.GetParameters]: getProcessConfigGetParameters(qpqConfig),
    });
});
exports.getConfigGetParametersActionProcessor = getConfigGetParametersActionProcessor;
