"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getConfigGetSecretActionProcessor = void 0;
const quidproquo_config_aws_1 = require("quidproquo-config-aws");
const quidproquo_core_1 = require("quidproquo-core");
const getSecret_1 = require("../../../logic/secretsManager/getSecret");
const utils_1 = require("./utils");
const getProcessConfigGetSecret = (qpqConfig) => {
    return ({ secretName }) => __awaiter(void 0, void 0, void 0, function* () {
        const awsSecretKey = (0, utils_1.resolveSecretResourceName)(secretName, qpqConfig);
        const secretValue = yield (0, getSecret_1.getSecret)(awsSecretKey, quidproquo_config_aws_1.qpqConfigAwsUtils.getApplicationModuleDeployRegion(qpqConfig));
        return (0, quidproquo_core_1.actionResult)(secretValue);
    });
};
const getConfigGetSecretActionProcessor = (qpqConfig) => __awaiter(void 0, void 0, void 0, function* () {
    return ({
        [quidproquo_core_1.ConfigActionType.GetSecret]: getProcessConfigGetSecret(qpqConfig),
    });
});
exports.getConfigGetSecretActionProcessor = getConfigGetSecretActionProcessor;
