"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getEventMatchStoryActionProcessor = void 0;
const quidproquo_core_1 = require("quidproquo-core");
const quidproquo_webserver_1 = require("quidproquo-webserver");
const types_1 = require("./types");
const getProcessMatchStory = (qpqConfig) => {
    const userDirectoryConfig = quidproquo_webserver_1.qpqWebServerUtils.getWebsocketEntryByApiName(types_1.GLOBAL_WEBSOCKET_API_NAME, qpqConfig);
    return ({ qpqEventRecord }) => __awaiter(void 0, void 0, void 0, function* () {
        switch (qpqEventRecord.eventType) {
            case quidproquo_webserver_1.WebSocketEventType.Connect:
                return (0, quidproquo_core_1.actionResult)({
                    runtime: userDirectoryConfig.eventProcessors.onConnect,
                });
            case quidproquo_webserver_1.WebSocketEventType.Disconnect:
                return (0, quidproquo_core_1.actionResult)({
                    runtime: userDirectoryConfig.eventProcessors.onDisconnect,
                });
            case quidproquo_webserver_1.WebSocketEventType.Message:
                return (0, quidproquo_core_1.actionResult)({
                    runtime: userDirectoryConfig.eventProcessors.onMessage,
                });
            default:
                return (0, quidproquo_core_1.actionResultError)(quidproquo_core_1.ErrorTypeEnum.NotFound, `Websocket lambda not implemented for ${qpqEventRecord.eventType}`);
        }
    });
};
const getEventMatchStoryActionProcessor = (qpqConfig) => __awaiter(void 0, void 0, void 0, function* () {
    return ({
        [quidproquo_core_1.EventActionType.MatchStory]: getProcessMatchStory(qpqConfig),
    });
});
exports.getEventMatchStoryActionProcessor = getEventMatchStoryActionProcessor;
