"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getEventMatchStoryActionProcessor = void 0;
const quidproquo_core_1 = require("quidproquo-core");
const quidproquo_webserver_1 = require("quidproquo-webserver");
const awsLambdaUtils_1 = require("../../../../awsLambdaUtils");
const getProcessMatchStory = (qpqConfig) => {
    const seoConfigs = quidproquo_webserver_1.qpqWebServerUtils.getAllSeo(qpqConfig);
    return ({ qpqEventRecord }) => __awaiter(void 0, void 0, void 0, function* () {
        // Sort the routes by string length
        // we don't sort them here for SEO... its the order they are defined.
        const sortedSeoConfigs = seoConfigs; // qpqWebServerUtils.sortPathMatchConfigs(seoConfigs);
        // Find the most relevant match
        const matchedSeoConfig = sortedSeoConfigs
            .map((r) => ({
            match: (0, awsLambdaUtils_1.matchUrl)(r.path, qpqEventRecord.path),
            route: r,
        }))
            .find((m) => m.match.didMatch);
        if (!matchedSeoConfig) {
            return (0, quidproquo_core_1.actionResultError)(quidproquo_core_1.ErrorTypeEnum.NotFound, `seo not found [${qpqEventRecord.path}]`);
        }
        return (0, quidproquo_core_1.actionResult)({
            runtime: matchedSeoConfig.route.runtime,
            runtimeOptions: matchedSeoConfig.match.params || {},
            config: matchedSeoConfig.route,
        });
    });
};
const getEventMatchStoryActionProcessor = (qpqConfig) => __awaiter(void 0, void 0, void 0, function* () {
    return ({
        [quidproquo_core_1.EventActionType.MatchStory]: getProcessMatchStory(qpqConfig),
    });
});
exports.getEventMatchStoryActionProcessor = getEventMatchStoryActionProcessor;
