"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getEventAutoRespondActionProcessor = void 0;
const quidproquo_core_1 = require("quidproquo-core");
const quidproquo_webserver_1 = require("quidproquo-webserver");
const types_1 = require("./types");
const getProcessAutoRespond = (qpqConfig) => {
    const userDirectoryConfig = quidproquo_core_1.qpqCoreUtils.getUserDirectories(qpqConfig).find((ud) => ud.name === types_1.GLOBAL_USER_DIRECTORY_NAME);
    return ({ qpqEventRecord, matchResult }) => __awaiter(void 0, void 0, void 0, function* () {
        const getErrorResult = () => (0, quidproquo_core_1.actionResultError)(quidproquo_core_1.ErrorTypeEnum.NotFound, `Email lambda not implemented for ${qpqEventRecord.eventType}`);
        switch (qpqEventRecord.eventType) {
            case quidproquo_webserver_1.EmailSendEventType.ResetPassword:
                if (!(userDirectoryConfig === null || userDirectoryConfig === void 0 ? void 0 : userDirectoryConfig.emailTemplates.resetPassword)) {
                    return getErrorResult();
                }
                break;
            case quidproquo_webserver_1.EmailSendEventType.ResetPasswordAdmin:
                if (!(userDirectoryConfig === null || userDirectoryConfig === void 0 ? void 0 : userDirectoryConfig.emailTemplates.resetPasswordAdmin)) {
                    return getErrorResult();
                }
                break;
            case quidproquo_webserver_1.EmailSendEventType.VerifyEmail:
                if (!(userDirectoryConfig === null || userDirectoryConfig === void 0 ? void 0 : userDirectoryConfig.emailTemplates.verifyEmail)) {
                    return getErrorResult();
                }
                break;
            default:
                return (0, quidproquo_core_1.actionResultError)(quidproquo_core_1.ErrorTypeEnum.NotFound, `Email processor not implemented for ${qpqEventRecord.eventType}`);
        }
        return (0, quidproquo_core_1.actionResult)(null);
    });
};
const getEventAutoRespondActionProcessor = (qpqConfig) => __awaiter(void 0, void 0, void 0, function* () {
    return ({
        [quidproquo_core_1.EventActionType.AutoRespond]: getProcessAutoRespond(qpqConfig),
    });
});
exports.getEventAutoRespondActionProcessor = getEventAutoRespondActionProcessor;
