"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getEventGetRecordsActionProcessor = void 0;
const quidproquo_core_1 = require("quidproquo-core");
const quidproquo_webserver_1 = require("quidproquo-webserver");
const getProcessGetRecords = (qpqConfig) => {
    return ({ eventParams: [customMessageTriggerEvent, context] }) => __awaiter(void 0, void 0, void 0, function* () {
        var _a;
        const internalEventRecord = {
            eventType: quidproquo_webserver_1.EmailSendEventType.VerifyEmail,
            code: customMessageTriggerEvent.request.codeParameter,
            link: customMessageTriggerEvent.request.linkParameter,
            attributes: customMessageTriggerEvent.request.userAttributes,
            username: customMessageTriggerEvent.request.usernameParameter,
        };
        switch (customMessageTriggerEvent.triggerSource) {
            case 'CustomMessage_ForgotPassword': {
                if (((_a = customMessageTriggerEvent.request.clientMetadata) === null || _a === void 0 ? void 0 : _a['userInitiated']) === 'true') {
                    internalEventRecord.eventType = quidproquo_webserver_1.EmailSendEventType.ResetPassword;
                }
                else {
                    internalEventRecord.eventType = quidproquo_webserver_1.EmailSendEventType.ResetPasswordAdmin;
                }
                break;
            }
            case 'CustomMessage_VerifyUserAttribute':
                internalEventRecord.eventType = quidproquo_webserver_1.EmailSendEventType.VerifyEmail;
                break;
        }
        return (0, quidproquo_core_1.actionResult)([internalEventRecord]);
    });
};
const getEventGetRecordsActionProcessor = (qpqConfig) => __awaiter(void 0, void 0, void 0, function* () {
    return ({
        [quidproquo_core_1.EventActionType.GetRecords]: getProcessGetRecords(qpqConfig),
    });
});
exports.getEventGetRecordsActionProcessor = getEventGetRecordsActionProcessor;
