"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getEventGetRecordsActionProcessor = void 0;
const quidproquo_core_1 = require("quidproquo-core");
const awsNamingUtils_1 = require("../../../../../awsNamingUtils");
const deployTypeMap = {
    UPDATE_COMPLETE: quidproquo_core_1.DeployEventStatusType.Update,
    CREATE_COMPLETE: quidproquo_core_1.DeployEventStatusType.Create,
    DELETE_COMPLETE: quidproquo_core_1.DeployEventStatusType.Delete,
};
const getProcessGetRecords = (qpqConfig) => {
    return ({ eventParams: [eventBridgeEvent, context] }) => __awaiter(void 0, void 0, void 0, function* () {
        const status = eventBridgeEvent.detail['status-details'].status || '';
        const stackId = eventBridgeEvent.detail['stack-id'];
        const regex = /:stack\/([^/]+)/;
        const match = stackId.match(regex);
        const stackName = match && match[1] ? match[1] : '';
        const internalEventRecord = {
            deployEventType: quidproquo_core_1.DeployEventType.Unknown,
            deployEventStatusType: deployTypeMap[status] || quidproquo_core_1.DeployEventStatusType.Unknown,
        };
        if (stackName === (0, awsNamingUtils_1.getApiStackName)(qpqConfig)) {
            internalEventRecord.deployEventType = quidproquo_core_1.DeployEventType.Api;
        }
        else if (stackName === (0, awsNamingUtils_1.getWebStackName)(qpqConfig)) {
            internalEventRecord.deployEventType = quidproquo_core_1.DeployEventType.Web;
        }
        console.log('internalEventRecord', internalEventRecord);
        return (0, quidproquo_core_1.actionResult)([internalEventRecord]);
    });
};
const getEventGetRecordsActionProcessor = (qpqConfig) => __awaiter(void 0, void 0, void 0, function* () {
    return ({
        [quidproquo_core_1.EventActionType.GetRecords]: getProcessGetRecords(qpqConfig),
    });
});
exports.getEventGetRecordsActionProcessor = getEventGetRecordsActionProcessor;
