"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getEventGetStorySessionActionProcessor = void 0;
const quidproquo_core_1 = require("quidproquo-core");
const getProcessGetStorySession = (qpqConfig) => {
    return ({ qpqEventRecord, eventParams: [sqsEvent] }) => __awaiter(void 0, void 0, void 0, function* () {
        // Find the src record and pull out the session from that if we can
        const srcRecord = sqsEvent.Records.find((r) => r.messageId === qpqEventRecord.id);
        if (srcRecord) {
            const parsedInternalEventRecord = JSON.parse(srcRecord.body);
            return (0, quidproquo_core_1.actionResult)(parsedInternalEventRecord.storySession);
        }
        return (0, quidproquo_core_1.actionResult)(void 0);
    });
};
const getEventGetStorySessionActionProcessor = (qpqConfig) => __awaiter(void 0, void 0, void 0, function* () {
    return ({
        [quidproquo_core_1.EventActionType.GetStorySession]: getProcessGetStorySession(qpqConfig),
    });
});
exports.getEventGetStorySessionActionProcessor = getEventGetStorySessionActionProcessor;
