"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getFileDeleteActionProcessor = void 0;
const quidproquo_config_aws_1 = require("quidproquo-config-aws");
const quidproquo_core_1 = require("quidproquo-core");
const s3Utils_1 = require("../../../logic/s3/s3Utils");
const utils_1 = require("./utils");
const getProcessFileDelete = (qpqConfig) => {
    return ({ drive, filepaths }) => __awaiter(void 0, void 0, void 0, function* () {
        const s3BucketName = (0, utils_1.resolveStorageDriveBucketName)(drive, qpqConfig);
        const errored = yield (0, s3Utils_1.deleteFiles)(s3BucketName, filepaths, quidproquo_config_aws_1.qpqConfigAwsUtils.getApplicationModuleDeployRegion(qpqConfig));
        // errored deletes are a graceful success ~ Retry
        // if (errored.length > 0) {
        //   return actionResultError(
        //     ErrorTypeEnum.GenericError,
        //     `Could not delete files ${errored.length}`,
        //   );
        // }
        return (0, quidproquo_core_1.actionResult)(errored);
    });
};
const getFileDeleteActionProcessor = (qpqConfig) => __awaiter(void 0, void 0, void 0, function* () {
    return ({
        [quidproquo_core_1.FileActionType.Delete]: getProcessFileDelete(qpqConfig),
    });
});
exports.getFileDeleteActionProcessor = getFileDeleteActionProcessor;
