"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getFileReadBinaryContentsActionProcessor = void 0;
const quidproquo_config_aws_1 = require("quidproquo-config-aws");
const quidproquo_core_1 = require("quidproquo-core");
const s3Utils_1 = require("../../../logic/s3/s3Utils");
const utils_1 = require("./utils");
const getProcessFileReadBinaryContents = (qpqConfig) => {
    return ({ drive, filepath }) => __awaiter(void 0, void 0, void 0, function* () {
        const s3BucketName = (0, utils_1.resolveStorageDriveBucketName)(drive, qpqConfig);
        return (0, quidproquo_core_1.actionResult)(yield (0, s3Utils_1.readBinaryFile)(s3BucketName, filepath, quidproquo_config_aws_1.qpqConfigAwsUtils.getApplicationModuleDeployRegion(qpqConfig)));
    });
};
const getFileReadBinaryContentsActionProcessor = (qpqConfig) => __awaiter(void 0, void 0, void 0, function* () {
    return ({
        [quidproquo_core_1.FileActionType.ReadBinaryContents]: getProcessFileReadBinaryContents(qpqConfig),
    });
});
exports.getFileReadBinaryContentsActionProcessor = getFileReadBinaryContentsActionProcessor;
