"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getGraphDatabaseForNeptuneGetEndpointsActionProcessor = void 0;
const quidproquo_config_aws_1 = require("quidproquo-config-aws");
const quidproquo_core_1 = require("quidproquo-core");
const awsNamingUtils_1 = require("../../../../../awsNamingUtils");
const neptune_1 = require("../../../../../logic/neptune");
const actions_1 = require("../actions");
const getProcessGetEndpoints = (qpqConfig) => {
    return ({ graphDatabaseName }) => __awaiter(void 0, void 0, void 0, function* () {
        const region = quidproquo_config_aws_1.qpqConfigAwsUtils.getApplicationModuleDeployRegion(qpqConfig);
        const databaseName = (0, awsNamingUtils_1.getConfigRuntimeResourceNameFromConfig)(graphDatabaseName, qpqConfig);
        try {
            const endpoints = yield (0, neptune_1.getNeptuneEndpoints)(databaseName, region);
            return (0, quidproquo_core_1.actionResult)(endpoints);
        }
        catch (error) {
            return (0, quidproquo_core_1.actionResultErrorFromCaughtError)(error, {});
        }
    });
};
const getGraphDatabaseForNeptuneGetEndpointsActionProcessor = (qpqConfig) => __awaiter(void 0, void 0, void 0, function* () {
    return ({
        [actions_1.GraphDatabaseForNeptuneActionType.GetEndpoints]: getProcessGetEndpoints(qpqConfig),
    });
});
exports.getGraphDatabaseForNeptuneGetEndpointsActionProcessor = getGraphDatabaseForNeptuneGetEndpointsActionProcessor;
