"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.askConvertAnyNeptuneResultToAnyGraphResult = void 0;
const quidproquo_core_1 = require("quidproquo-core");
const askConvertNeptuneNodeResultToGraphNodeResult_1 = require("./askConvertNeptuneNodeResultToGraphNodeResult");
const askConvertNeptuneRelationshipResultToGraphRelationshipResult_1 = require("./askConvertNeptuneRelationshipResultToGraphRelationshipResult");
const utils_1 = require("./utils");
function* askConvertAnyNeptuneResultToAnyGraphResult(anyNeptuneResult) {
    if ((0, utils_1.isNeptuneScalarResult)(anyNeptuneResult)) {
        return anyNeptuneResult;
    }
    if ((0, utils_1.isNeptuneNodeResult)(anyNeptuneResult)) {
        return yield* (0, askConvertNeptuneNodeResultToGraphNodeResult_1.askConvertNeptuneNodeResultToGraphNodeResult)(anyNeptuneResult);
    }
    if ((0, utils_1.isNeptuneRelationshipResult)(anyNeptuneResult)) {
        return yield* (0, askConvertNeptuneRelationshipResultToGraphRelationshipResult_1.askConvertNeptuneRelationshipResultToGraphRelationshipResult)(anyNeptuneResult);
    }
    return yield* (0, quidproquo_core_1.askThrowError)(quidproquo_core_1.ErrorTypeEnum.GenericError, 'Unable to convert neptune query result');
}
exports.askConvertAnyNeptuneResultToAnyGraphResult = askConvertAnyNeptuneResultToAnyGraphResult;
