"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getKeyValueStoreGetActionProcessor = void 0;
const quidproquo_config_aws_1 = require("quidproquo-config-aws");
const quidproquo_core_1 = require("quidproquo-core");
const awsNamingUtils_1 = require("../../../awsNamingUtils");
const dynamo_1 = require("../../../logic/dynamo");
const getProcessKeyValueStoreGet = (qpqConfig) => {
    return ({ keyValueStoreName, key }) => __awaiter(void 0, void 0, void 0, function* () {
        const dynamoTableName = (0, awsNamingUtils_1.getKvsDynamoTableNameFromConfig)(keyValueStoreName, qpqConfig, 'kvs');
        const region = quidproquo_config_aws_1.qpqConfigAwsUtils.getApplicationModuleDeployRegion(qpqConfig);
        const result = yield (0, dynamo_1.getItem)(dynamoTableName, key, region);
        return (0, quidproquo_core_1.actionResult)(result);
    });
};
const getKeyValueStoreGetActionProcessor = (qpqConfig) => __awaiter(void 0, void 0, void 0, function* () {
    return ({
        [quidproquo_core_1.KeyValueStoreActionType.Get]: getProcessKeyValueStoreGet(qpqConfig),
    });
});
exports.getKeyValueStoreGetActionProcessor = getKeyValueStoreGetActionProcessor;
