"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getUserDirectoryCreateUserActionProcessor = void 0;
const quidproquo_config_aws_1 = require("quidproquo-config-aws");
const quidproquo_core_1 = require("quidproquo-core");
const awsNamingUtils_1 = require("../../../awsNamingUtils");
const getExportedValue_1 = require("../../../logic/cloudformation/getExportedValue");
const createUser_1 = require("../../../logic/cognito/createUser");
const getProcessCreateUser = (qpqConfig) => {
    return (payload) => __awaiter(void 0, void 0, void 0, function* () {
        const region = quidproquo_config_aws_1.qpqConfigAwsUtils.getApplicationModuleDeployRegion(qpqConfig);
        const userPoolId = yield (0, getExportedValue_1.getExportedValue)((0, awsNamingUtils_1.getCFExportNameUserPoolIdFromConfig)(payload.userDirectoryName, qpqConfig), region);
        const userPoolClientId = yield (0, getExportedValue_1.getExportedValue)((0, awsNamingUtils_1.getCFExportNameUserPoolClientIdFromConfig)(payload.userDirectoryName, qpqConfig), region);
        const authResponse = yield (0, createUser_1.createUser)(userPoolId, quidproquo_config_aws_1.qpqConfigAwsUtils.getApplicationModuleDeployRegion(qpqConfig), userPoolClientId, payload.createUserRequest);
        return (0, quidproquo_core_1.actionResult)(authResponse);
    });
};
const getUserDirectoryCreateUserActionProcessor = (qpqConfig) => __awaiter(void 0, void 0, void 0, function* () {
    return ({
        [quidproquo_core_1.UserDirectoryActionType.CreateUser]: getProcessCreateUser(qpqConfig),
    });
});
exports.getUserDirectoryCreateUserActionProcessor = getUserDirectoryCreateUserActionProcessor;
