"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getUserDirectoryGetUsersByAttributeActionProcessor = void 0;
const quidproquo_config_aws_1 = require("quidproquo-config-aws");
const quidproquo_core_1 = require("quidproquo-core");
const awsNamingUtils_1 = require("../../../awsNamingUtils");
const getExportedValue_1 = require("../../../logic/cloudformation/getExportedValue");
const listPagedUsersByAttribute_1 = require("../../../logic/cognito/listPagedUsersByAttribute");
const getProcessGetUsersByAttribute = (qpqConfig) => {
    return ({ userDirectoryName, attribueName, attribueValue, limit, nextPageKey }, _session) => __awaiter(void 0, void 0, void 0, function* () {
        const region = quidproquo_config_aws_1.qpqConfigAwsUtils.getApplicationModuleDeployRegion(qpqConfig);
        const userPoolId = yield (0, getExportedValue_1.getExportedValue)((0, awsNamingUtils_1.getCFExportNameUserPoolIdFromConfig)(userDirectoryName, qpqConfig), region);
        const userAttributes = yield (0, listPagedUsersByAttribute_1.listPagedUsersByAttribute)(userPoolId, region, attribueName, attribueValue, limit, nextPageKey);
        return (0, quidproquo_core_1.actionResult)(userAttributes);
    });
};
const getUserDirectoryGetUsersByAttributeActionProcessor = (qpqConfig) => __awaiter(void 0, void 0, void 0, function* () {
    return ({
        [quidproquo_core_1.UserDirectoryActionType.GetUsersByAttribute]: getProcessGetUsersByAttribute(qpqConfig),
    });
});
exports.getUserDirectoryGetUsersByAttributeActionProcessor = getUserDirectoryGetUsersByAttributeActionProcessor;
