"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getUserDirectoryReadAccessTokenActionProcessor = void 0;
const quidproquo_core_1 = require("quidproquo-core");
const decodeAccessToken_1 = require("../../../logic/cognito/decodeAccessToken");
const getProcessReadAccessToken = (qpqConfig) => {
    return ({ userDirectoryName, ignoreExpiration }, { decodedAccessToken, accessToken }) => __awaiter(void 0, void 0, void 0, function* () {
        if (decodedAccessToken) {
            if (!ignoreExpiration && decodedAccessToken.exp < Math.floor(Date.now() / 1000)) {
                return (0, quidproquo_core_1.actionResultError)(quidproquo_core_1.ErrorTypeEnum.Invalid, 'Access has expired');
            }
            return (0, quidproquo_core_1.actionResult)(decodedAccessToken);
        }
        const decodedAuthToken = yield (0, decodeAccessToken_1.decodeAccessToken)(userDirectoryName, qpqConfig, accessToken, ignoreExpiration);
        if (!decodedAuthToken || !decodedAuthToken.username) {
            return (0, quidproquo_core_1.actionResultError)(quidproquo_core_1.ErrorTypeEnum.Unauthorized, 'Invalid accessToken');
        }
        return (0, quidproquo_core_1.actionResult)(decodedAuthToken);
    });
};
const getUserDirectoryReadAccessTokenActionProcessor = (qpqConfig) => __awaiter(void 0, void 0, void 0, function* () {
    return ({
        [quidproquo_core_1.UserDirectoryActionType.ReadAccessToken]: getProcessReadAccessToken(qpqConfig),
    });
});
exports.getUserDirectoryReadAccessTokenActionProcessor = getUserDirectoryReadAccessTokenActionProcessor;
