"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getUserDirectorySetAccessTokenActionProcessor = void 0;
const quidproquo_core_1 = require("quidproquo-core");
const cognito_1 = require("../../../logic/cognito");
const getProcessSetAccessToken = (qpqConfig) => {
    return ({ accessToken, userDirectoryName }, session, apl, logger, updateSession) => __awaiter(void 0, void 0, void 0, function* () {
        const decodedAccessToken = yield (0, cognito_1.decodeAccessToken)(userDirectoryName, qpqConfig, accessToken, false);
        updateSession({
            decodedAccessToken: decodedAccessToken,
            accessToken,
        });
        return (0, quidproquo_core_1.actionResult)(decodedAccessToken);
    });
};
const getUserDirectorySetAccessTokenActionProcessor = (qpqConfig) => __awaiter(void 0, void 0, void 0, function* () {
    return ({
        [quidproquo_core_1.UserDirectoryActionType.SetAccessToken]: getProcessSetAccessToken(qpqConfig),
    });
});
exports.getUserDirectorySetAccessTokenActionProcessor = getUserDirectorySetAccessTokenActionProcessor;
