"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getCloudFrontRequestEvent_viewerRequest = exports.viewerRequestEventHandler = void 0;
const quidproquo_webserver_1 = require("quidproquo-webserver");
const viewerRequestEventHandler = (event, context) => __awaiter(void 0, void 0, void 0, function* () {
    var _a;
    console.log(JSON.stringify(event));
    const request = event.Records[0].cf.request;
    const headers = request.headers;
    const userAgent = ((_a = headers['user-agent'][0]) === null || _a === void 0 ? void 0 : _a.value) || 'unknown';
    // let isBot = userAgent.match(/bot|crawl|spider|slurp|facebot|facebookexternalhit/i);
    // Bot testing for integrating Prerender ~ you then do what you want inside the app business logic
    // For more info: https://docs.prerender.io/docs/apache-2
    let isBot = userAgent.match(/googlebot|bingbot|yandex|baiduspider|facebookexternalhit|twitterbot|rogerbot|linkedinbot|embedly|quora link preview|showyoubot|outbrain|pinterest\/0\.|pinterestbot|slackbot|vkShare|W3C_Validator|whatsapp|redditbot|applebot|flipboard|tumblr|bitlybot|skypeuripreview|nuzzel|discordbot|google page speed|qwantify|bitrix link preview|xing-contenttabreceiver|google-inspectiontool|chrome-lighthouse|telegrambot/i);
    return Object.assign(Object.assign({}, request), { headers: Object.assign(Object.assign({}, request.headers), { [quidproquo_webserver_1.qpqHeaderIsBot]: [
                {
                    key: quidproquo_webserver_1.qpqHeaderIsBot,
                    value: isBot ? 'true' : 'false',
                },
            ] }) });
});
exports.viewerRequestEventHandler = viewerRequestEventHandler;
// Default executor
const getCloudFrontRequestEvent_viewerRequest = () => exports.viewerRequestEventHandler;
exports.getCloudFrontRequestEvent_viewerRequest = getCloudFrontRequestEvent_viewerRequest;
