"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getExportedValue = void 0;
const client_cloudformation_1 = require("@aws-sdk/client-cloudformation");
const memoFuncAsync_1 = require("../cache/memoFuncAsync");
const createAwsClient_1 = require("../createAwsClient");
exports.getExportedValue = (0, memoFuncAsync_1.memoFuncAsync)((variableName, region) => __awaiter(void 0, void 0, void 0, function* () {
    var _a;
    const cloudformation = (0, createAwsClient_1.createAwsClient)(client_cloudformation_1.CloudFormationClient, { region });
    const listCommandParams = {};
    do {
        const result = yield cloudformation.send(new client_cloudformation_1.ListExportsCommand(listCommandParams));
        const value = (_a = (result.Exports || []).find((e) => e.Name === variableName)) === null || _a === void 0 ? void 0 : _a.Value;
        if (value !== undefined) {
            console.log(`CF Found: [${variableName}] = [${value}]`);
            return value;
        }
        listCommandParams.NextToken = result.NextToken;
    } while (listCommandParams.NextToken);
    throw new Error(`CF could not find: [${variableName}]`);
}));
