"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getUserAttributesBySub = void 0;
const client_cognito_identity_provider_1 = require("@aws-sdk/client-cognito-identity-provider");
const createAwsClient_1 = require("../createAwsClient");
const cognitoAttributeMap_1 = require("./cognitoAttributeMap");
const getUserAttributesBySub = (userPoolId, region, sub) => __awaiter(void 0, void 0, void 0, function* () {
    const cognitoClient = (0, createAwsClient_1.createAwsClient)(client_cognito_identity_provider_1.CognitoIdentityProviderClient, {
        region,
    });
    const response = yield cognitoClient.send(new client_cognito_identity_provider_1.ListUsersCommand({
        UserPoolId: userPoolId,
        Filter: `sub = "${sub}"`,
    }));
    const [user] = (response === null || response === void 0 ? void 0 : response.Users) || [];
    if (!user) {
        throw new Error('User not found');
    }
    const validAttributes = (user.Attributes || []).filter((attr) => attr.Name && attr.Value);
    return (0, cognitoAttributeMap_1.getQpqAttributesFromCognitoUserAttributes)(validAttributes);
});
exports.getUserAttributesBySub = getUserAttributesBySub;
