"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.setParameter = void 0;
const client_ssm_1 = require("@aws-sdk/client-ssm");
const createAwsClient_1 = require("../createAwsClient");
const setParameter = (parameterName, region, value) => __awaiter(void 0, void 0, void 0, function* () {
    const ssmClient = (0, createAwsClient_1.createAwsClient)(client_ssm_1.SSMClient, { region });
    yield ssmClient.send(new client_ssm_1.PutParameterCommand({
        Name: parameterName,
        Value: value,
        Overwrite: true,
        Type: client_ssm_1.ParameterType.STRING,
    }));
});
exports.setParameter = setParameter;
