"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getObjectStorageClass = void 0;
const client_s3_1 = require("@aws-sdk/client-s3");
const createAwsClient_1 = require("../createAwsClient");
const getObjectStorageClass = (bucketName, key, region) => __awaiter(void 0, void 0, void 0, function* () {
    const s3Client = (0, createAwsClient_1.createAwsClient)(client_s3_1.S3Client, { region });
    const response = yield s3Client.send(new client_s3_1.HeadObjectCommand({
        Key: key,
        Bucket: bucketName,
    }));
    // Map AWS StorageClass to our custom labels
    switch (response.StorageClass) {
        case 'GLACIER':
        case 'GLACIER_IR':
        case 'DEEP_ARCHIVE':
        case 'ONEZONE_IA':
        case 'EXPRESS_ONEZONE':
        case 'OUTPOSTS':
        case 'SNOW':
            return 'cold_storage';
        case 'STANDARD_IA':
        case 'STANDARD':
        case 'INTELLIGENT_TIERING':
        case 'REDUCED_REDUNDANCY':
        default:
            return 'standard';
    }
});
exports.getObjectStorageClass = getObjectStorageClass;
