"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.publishMessage = void 0;
const client_sns_1 = require("@aws-sdk/client-sns");
const createAwsClient_1 = require("../createAwsClient");
const publishMessage = (topicArn, region, messages) => __awaiter(void 0, void 0, void 0, function* () {
    const sqsClient = (0, createAwsClient_1.createAwsClient)(client_sns_1.SNSClient, { region });
    // Convert them to entries
    const entries = messages.map((message, index) => ({
        Message: message,
        Id: `${index}`,
        // MessageAttributes: {
        //   type: {
        //     DataType: 'String',
        //     StringValue: JSON.parse(message).type,
        //   },
        // },
    }));
    // now send them off in batches of 10
    // We want to await incase of FIFO
    // If you don't care about order, you can split and askParallel outside of this
    while (entries.length > 0) {
        // Not sure the max batch size, although the entire payload cant be bigger then 256 KB
        // TODO: So maybe we should split based on payload sizes
        const entriesBatch = entries.splice(0, 10);
        yield sqsClient.send(new client_sns_1.PublishBatchCommand({
            TopicArn: topicArn,
            PublishBatchRequestEntries: entriesBatch,
        }));
    }
});
exports.publishMessage = publishMessage;
