import { qpqConfigAwsUtils } from 'quidproquo-config-aws';
import { actionResult, actionResultError, actionResultErrorFromCaughtError, ConfigActionType, ConfigGetParameterErrorTypeEnum, } from 'quidproquo-core';
import { getParameter } from '../../../logic/parametersManager/getParameter';
import { resolveParameterKey } from '../../../runtimeConfig/qpqAwsLambdaRuntimeConfigUtils';
const getProcessConfigGetParameter = (qpqConfig) => {
    return async ({ parameterName }) => {
        const awsParameterKey = resolveParameterKey(parameterName, qpqConfig);
        try {
            const parameterValue = await getParameter(awsParameterKey, qpqConfigAwsUtils.getApplicationModuleDeployRegion(qpqConfig));
            return actionResult(parameterValue);
        }
        catch (error) {
            return actionResultErrorFromCaughtError(error, {
                ThrottlingException: () => actionResultError(ConfigGetParameterErrorTypeEnum.Throttling, 'Throttling: Rate exceeded'),
            });
        }
    };
};
export const getConfigGetParameterActionProcessor = async (qpqConfig) => ({
    [ConfigActionType.GetParameter]: getProcessConfigGetParameter(qpqConfig),
});
