import { qpqConfigAwsUtils } from 'quidproquo-config-aws';
import { actionResult, ConfigActionType, } from 'quidproquo-core';
import { getSecret } from '../../../logic/secretsManager/getSecret';
import { resolveSecretResourceName } from './utils';
const getProcessConfigGetSecret = (qpqConfig) => {
    return async ({ secretName }) => {
        const awsSecretKey = resolveSecretResourceName(secretName, qpqConfig);
        const secretValue = await getSecret(awsSecretKey, qpqConfigAwsUtils.getApplicationModuleDeployRegion(qpqConfig));
        return actionResult(secretValue);
    };
};
export const getConfigGetSecretActionProcessor = async (qpqConfig) => ({
    [ConfigActionType.GetSecret]: getProcessConfigGetSecret(qpqConfig),
});
