import { qpqConfigAwsUtils } from 'quidproquo-config-aws';
import { actionResult, ConfigActionType, } from 'quidproquo-core';
import { setParameter } from '../../../logic/parametersManager/setParameter';
import { resolveParameterKey } from '../../../runtimeConfig/qpqAwsLambdaRuntimeConfigUtils';
const getProcessConfigSetParameter = (qpqConfig) => {
    return async ({ parameterName, parameterValue }) => {
        const awsParameterKey = resolveParameterKey(parameterName, qpqConfig);
        await setParameter(awsParameterKey, qpqConfigAwsUtils.getApplicationModuleDeployRegion(qpqConfig), parameterValue);
        return actionResult(void 0);
    };
};
export const getConfigSetParameterActionProcessor = async (qpqConfig) => ({
    [ConfigActionType.SetParameter]: getProcessConfigSetParameter(qpqConfig),
});
