import { actionResult, EventActionType, } from 'quidproquo-core';
import { WebSocketEventType } from 'quidproquo-webserver';
import { GLOBAL_WEBSOCKET_API_NAME } from './types';
const awsToQoqEventTypeMap = {
    MESSAGE: WebSocketEventType.Message,
    CONNECT: WebSocketEventType.Connect,
    DISCONNECT: WebSocketEventType.Disconnect,
};
const getProcessGetRecords = (qpqConfig) => {
    return async ({ eventParams: [websocketEvent, context] }) => {
        const internalEventRecord = {
            eventType: awsToQoqEventTypeMap[websocketEvent.requestContext.eventType],
            messageId: websocketEvent.requestContext.messageId,
            connectionId: websocketEvent.requestContext.connectionId,
            requestTimeEpoch: websocketEvent.requestContext.requestTimeEpoch,
            sourceIp: websocketEvent.requestContext.identity.sourceIp,
            userAgent: websocketEvent.requestContext.identity.userAgent,
            requestTime: new Date(websocketEvent.requestContext.requestTimeEpoch).toISOString(),
            body: websocketEvent.body,
            apiName: GLOBAL_WEBSOCKET_API_NAME,
        };
        return actionResult([internalEventRecord]);
    };
};
export const getEventGetRecordsActionProcessor = async (qpqConfig) => ({
    [EventActionType.GetRecords]: getProcessGetRecords(qpqConfig),
});
