import { actionResult, actionResultError, ErrorTypeEnum, EventActionType, } from 'quidproquo-core';
import { qpqWebServerUtils, WebSocketEventType } from 'quidproquo-webserver';
import { GLOBAL_WEBSOCKET_API_NAME } from './types';
const getProcessMatchStory = (qpqConfig) => {
    const userDirectoryConfig = qpqWebServerUtils.getWebsocketEntryByApiName(GLOBAL_WEBSOCKET_API_NAME, qpqConfig);
    return async ({ qpqEventRecord }) => {
        switch (qpqEventRecord.eventType) {
            case WebSocketEventType.Connect:
                return actionResult({
                    runtime: userDirectoryConfig.eventProcessors.onConnect,
                });
            case WebSocketEventType.Disconnect:
                return actionResult({
                    runtime: userDirectoryConfig.eventProcessors.onDisconnect,
                });
            case WebSocketEventType.Message:
                return actionResult({
                    runtime: userDirectoryConfig.eventProcessors.onMessage,
                });
            default:
                return actionResultError(ErrorTypeEnum.NotFound, `Websocket lambda not implemented for ${qpqEventRecord.eventType}`);
        }
    };
};
export const getEventMatchStoryActionProcessor = async (qpqConfig) => ({
    [EventActionType.MatchStory]: getProcessMatchStory(qpqConfig),
});
