import { MatchStoryResult } from 'quidproquo-core';
import { WebsocketEvent, WebsocketEventResponse } from 'quidproquo-webserver';
import { APIGatewayEventWebsocketRequestContextV2, APIGatewayProxyResultV2, APIGatewayProxyWebsocketEventV2WithRequestContext, Context } from 'aws-lambda';
type ApiGatwayEventWebsocketWithIdentity = APIGatewayProxyWebsocketEventV2WithRequestContext<APIGatewayEventWebsocketRequestContextV2 & {
    identity: {
        sourceIp: string;
        userAgent: string;
    };
}>;
export declare const GLOBAL_WEBSOCKET_API_NAME: string;
export type EventInput = [ApiGatwayEventWebsocketWithIdentity, Context];
export type EventOutput = APIGatewayProxyResultV2;
export type InternalEventRecord = WebsocketEvent<string | Blob | ArrayBuffer>;
export type InternalEventOutput = WebsocketEventResponse;
export type MatchResult = MatchStoryResult<any, any>;
export {};
