import { actionResult, actionResultError, ErrorTypeEnum, EventActionType, qpqCoreUtils, } from 'quidproquo-core';
import { EmailSendEventType } from 'quidproquo-webserver';
// TODO: Don't use Globals like this
const GLOBAL_USER_DIRECTORY_NAME = process.env.userDirectoryName;
const getProcessMatchStory = (qpqConfig) => {
    const userDirectoryConfig = qpqCoreUtils.getUserDirectories(qpqConfig).find((ud) => ud.name === GLOBAL_USER_DIRECTORY_NAME);
    return async ({ qpqEventRecord }) => {
        switch (qpqEventRecord.eventType) {
            case EmailSendEventType.ResetPassword:
                return actionResult({
                    runtime: userDirectoryConfig?.emailTemplates.resetPassword,
                });
            case EmailSendEventType.ResetPasswordAdmin:
                return actionResult({
                    runtime: userDirectoryConfig?.emailTemplates.resetPasswordAdmin,
                });
            case EmailSendEventType.VerifyEmail:
                return actionResult({
                    runtime: userDirectoryConfig?.emailTemplates.verifyEmail,
                });
            default:
                return actionResultError(ErrorTypeEnum.NotFound, `Email lambda not implemented for ${qpqEventRecord.eventType}`);
        }
    };
};
export const getEventMatchStoryActionProcessor = async (qpqConfig) => ({
    [EventActionType.MatchStory]: getProcessMatchStory(qpqConfig),
});
