import { actionResult, EventActionType, } from 'quidproquo-core';
import { getQpqAttributesFromCognitoStringMap } from '../../../../../logic/cognito/cognitoAttributeMap';
const getProcessGetRecords = (qpqConfig) => {
    return async ({ eventParams: [event, context] }) => {
        const internalEventRecord = {
            challengeAnswer: event.request.challengeAnswer ? JSON.parse(event.request.challengeAnswer) : {},
            userAttributes: getQpqAttributesFromCognitoStringMap(event.request.userAttributes),
            userNotFound: event.request.userNotFound,
            privateChallengeParameters: event.request.privateChallengeParameters,
        };
        return actionResult([internalEventRecord]);
    };
};
export const getEventGetRecordsActionProcessor = async (qpqConfig) => ({
    [EventActionType.GetRecords]: getProcessGetRecords(qpqConfig),
});
