import { actionResult, actionResultError, ErrorTypeEnum, EventActionType, qpqCoreUtils, } from 'quidproquo-core';
// TODO: Globals? Are these bad....
const GLOBAL_DEPLOY_EVENT_NAME = process.env.deployEventConfigName;
const getProcessMatchStory = (qpqConfig) => {
    const deployConfig = qpqCoreUtils.getDeployEventConfigs(qpqConfig).find((c) => c.name === GLOBAL_DEPLOY_EVENT_NAME);
    return async ({ qpqEventRecord }) => {
        if (!deployConfig) {
            return actionResultError(ErrorTypeEnum.NotFound, `Could not find deploy event config ${GLOBAL_DEPLOY_EVENT_NAME}`);
        }
        return actionResult({
            runtime: deployConfig.runtime,
        });
    };
};
export const getEventMatchStoryActionProcessor = async (qpqConfig) => ({
    [EventActionType.MatchStory]: getProcessMatchStory(qpqConfig),
});
