import { actionResult, actionResultError, EventActionType, } from 'quidproquo-core';
const getProcessTransformResponseResult = (qpqConfig) => {
    return async ({ eventParams, qpqEventRecordResponses }) => {
        const [record] = qpqEventRecordResponses;
        // Throw back to caller if the logic errors..
        if (!record.success) {
            return actionResultError(record.error.errorType, record.error.errorText, record.error.errorStack);
        }
        // Transform back to api gateway
        return actionResult(void 0);
    };
};
export const getEventTransformResponseResultActionProcessor = async (qpqConfig) => ({
    [EventActionType.TransformResponseResult]: getProcessTransformResponseResult(qpqConfig),
});
