import { actionResult, actionResultError, ErrorTypeEnum, EventActionType, } from 'quidproquo-core';
import { qpqWebServerUtils } from 'quidproquo-webserver';
const getProcessMatchStory = (qpqConfig) => {
    const serviceFunctions = qpqWebServerUtils.getAllServiceFunctions(qpqConfig);
    return async ({ qpqEventRecord }) => {
        // Find the most relevant match
        const matchedRoute = serviceFunctions.find((sf) => sf.functionName === qpqEventRecord.functionName);
        if (!matchedRoute) {
            return actionResultError(ErrorTypeEnum.NotFound, `service function not found [${qpqEventRecord.functionName}]`);
        }
        return actionResult({
            runtime: matchedRoute.runtime,
        });
    };
};
export const getEventMatchStoryActionProcessor = async (qpqConfig) => ({
    [EventActionType.MatchStory]: getProcessMatchStory(qpqConfig),
});
