import { actionResult, EventActionType, } from 'quidproquo-core';
import { StorageDriveEventType } from 'quidproquo-webserver';
import { GLOBAL_STORAGE_DRIVE_NAME } from './types';
const getProcessGetRecords = (qpqConfig) => {
    return async ({ eventParams: [s3Event, context] }) => {
        const records = s3Event.Records.map((r) => {
            const internalEventRecord = {
                driveName: GLOBAL_STORAGE_DRIVE_NAME,
                // TODO: This only needs to be a single filepath now!
                filePaths: [decodeURIComponent(r.s3.object.key)],
                eventType: r.eventName.startsWith('ObjectCreated') ? StorageDriveEventType.Create : StorageDriveEventType.Delete,
            };
            return internalEventRecord;
        });
        return actionResult(records);
    };
};
export const getEventGetRecordsActionProcessor = async (qpqConfig) => ({
    [EventActionType.GetRecords]: getProcessGetRecords(qpqConfig),
});
