import { actionResult, actionResultError, ErrorTypeEnum, EventActionType, } from 'quidproquo-core';
const getProcessTransformResponseResult = (qpqConfig) => {
    // We might need to JSON.stringify the body.
    return async ({ eventParams, qpqEventRecordResponses }) => {
        const onesThatErrored = qpqEventRecordResponses.filter((r) => !r.success);
        if (onesThatErrored.length > 0) {
            return actionResultError(ErrorTypeEnum.GenericError, `[${onesThatErrored.length}] files unable to be processed.`);
        }
        // Transform back to api gateway
        return actionResult(void 0);
    };
};
export const getEventTransformResponseResultActionProcessor = async (qpqConfig) => ({
    [EventActionType.TransformResponseResult]: getProcessTransformResponseResult(qpqConfig),
});
