import { actionResult, EventActionType, } from 'quidproquo-core';
const getProcessGetStorySession = (qpqConfig) => {
    return async ({ qpqEventRecord, eventParams: [sqsEvent] }) => {
        // Find the src record and pull out the session from that if we can
        const srcRecord = sqsEvent.Records.find((r) => r.messageId === qpqEventRecord.id);
        if (srcRecord) {
            const parsedInternalEventRecord = JSON.parse(srcRecord.body);
            return actionResult(parsedInternalEventRecord.storySession);
        }
        return actionResult(void 0);
    };
};
export const getEventGetStorySessionActionProcessor = async (qpqConfig) => ({
    [EventActionType.GetStorySession]: getProcessGetStorySession(qpqConfig),
});
