import { qpqConfigAwsUtils } from 'quidproquo-config-aws';
import { actionResult, FileActionType, } from 'quidproquo-core';
import { objectExists } from '../../../logic/s3/s3Utils';
import { resolveStorageDriveBucketName } from './utils';
const getProcessFileExists = (qpqConfig) => {
    return async ({ drive, filepath }) => {
        const s3BucketName = resolveStorageDriveBucketName(drive, qpqConfig);
        return actionResult(await objectExists(s3BucketName, filepath, qpqConfigAwsUtils.getApplicationModuleDeployRegion(qpqConfig)));
    };
};
export const getFileExistsActionProcessor = async (qpqConfig) => ({
    [FileActionType.Exists]: getProcessFileExists(qpqConfig),
});
