import { qpqConfigAwsUtils } from 'quidproquo-config-aws';
import { actionResult, FileActionType, } from 'quidproquo-core';
import { readBinaryFile } from '../../../logic/s3/s3Utils';
import { resolveStorageDriveBucketName } from './utils';
const getProcessFileReadBinaryContents = (qpqConfig) => {
    return async ({ drive, filepath }) => {
        const s3BucketName = resolveStorageDriveBucketName(drive, qpqConfig);
        return actionResult(await readBinaryFile(s3BucketName, filepath, qpqConfigAwsUtils.getApplicationModuleDeployRegion(qpqConfig)));
    };
};
export const getFileReadBinaryContentsActionProcessor = async (qpqConfig) => ({
    [FileActionType.ReadBinaryContents]: getProcessFileReadBinaryContents(qpqConfig),
});
