import { qpqConfigAwsUtils } from 'quidproquo-config-aws';
import { actionResult, actionResultError, actionResultErrorFromCaughtError, FileActionType, FileReadTextContentsErrorTypeEnum, } from 'quidproquo-core';
import { readTextFile } from '../../../logic/s3/s3Utils';
import { resolveStorageDriveBucketName } from './utils';
const getProcessFileReadTextContents = (qpqConfig) => {
    return async ({ drive, filepath }) => {
        try {
            const s3BucketName = resolveStorageDriveBucketName(drive, qpqConfig);
            return actionResult(await readTextFile(s3BucketName, filepath, qpqConfigAwsUtils.getApplicationModuleDeployRegion(qpqConfig)));
        }
        catch (error) {
            return actionResultErrorFromCaughtError(error, {
                InvalidObjectState: () => actionResultError(FileReadTextContentsErrorTypeEnum.InvalidStorageClass, 'File is in the wrong storage class'),
            });
        }
    };
};
export const getFileReadTextContentsActionProcessor = async (qpqConfig) => ({
    [FileActionType.ReadTextContents]: getProcessFileReadTextContents(qpqConfig),
});
