import { qpqConfigAwsUtils } from 'quidproquo-config-aws';
import { actionResult, actionResultErrorFromCaughtError } from 'quidproquo-core';
import { getConfigRuntimeResourceNameFromConfig } from '../../../../../awsNamingUtils';
import { getNeptuneEndpoints } from '../../../../../logic/neptune';
import { GraphDatabaseForNeptuneActionType } from '../actions';
const getProcessGetEndpoints = (qpqConfig) => {
    return async ({ graphDatabaseName }) => {
        const region = qpqConfigAwsUtils.getApplicationModuleDeployRegion(qpqConfig);
        const databaseName = getConfigRuntimeResourceNameFromConfig(graphDatabaseName, qpqConfig);
        try {
            const endpoints = await getNeptuneEndpoints(databaseName, region);
            return actionResult(endpoints);
        }
        catch (error) {
            return actionResultErrorFromCaughtError(error, {});
        }
    };
};
export const getGraphDatabaseForNeptuneGetEndpointsActionProcessor = async (qpqConfig) => ({
    [GraphDatabaseForNeptuneActionType.GetEndpoints]: getProcessGetEndpoints(qpqConfig),
});
