export interface NeptuneGraphEntity {
    '~id': string;
    '~properties': Record<string, any>;
}
export interface NeptuneNodeResult extends NeptuneGraphEntity {
    '~entityType': 'node';
    '~labels': string[];
}
export interface NeptuneRelationshipResult extends NeptuneGraphEntity {
    '~entityType': 'relationship';
    '~start': string;
    '~end': string;
    '~type': string;
}
export type NeptuneScalarResult = number | string | boolean | null;
export type AnyNeptuneResult = NeptuneNodeResult | NeptuneRelationshipResult | NeptuneScalarResult;
export interface NeptuneQueryResult {
    [key: string]: AnyNeptuneResult;
}
export interface NeptuneCypherRequest {
    query: string;
    parameters?: Record<string, any>;
}
export interface NeptuneCypherResponse {
    results: NeptuneQueryResult[];
}
