import { qpqConfigAwsUtils } from 'quidproquo-config-aws';
import { actionResult, KeyValueStoreActionType } from 'quidproquo-core';
import { getKvsDynamoTableNameFromConfig } from '../../../awsNamingUtils';
import { getItem } from '../../../logic/dynamo';
const getProcessKeyValueStoreGet = (qpqConfig) => {
    return async ({ keyValueStoreName, key }) => {
        const dynamoTableName = getKvsDynamoTableNameFromConfig(keyValueStoreName, qpqConfig, 'kvs');
        const region = qpqConfigAwsUtils.getApplicationModuleDeployRegion(qpqConfig);
        const result = await getItem(dynamoTableName, key, region);
        return actionResult(result);
    };
};
export const getKeyValueStoreGetActionProcessor = async (qpqConfig) => ({
    [KeyValueStoreActionType.Get]: getProcessKeyValueStoreGet(qpqConfig),
});
