import { qpqConfigAwsUtils } from 'quidproquo-config-aws';
import { actionResult, KeyValueStoreActionType } from 'quidproquo-core';
import { getKvsDynamoTableNameFromConfig } from '../../../awsNamingUtils';
import { getAllItems } from '../../../logic/dynamo';
const getProcessKeyValueStoreGetAll = (qpqConfig) => {
    return async ({ keyValueStoreName }) => {
        const dynamoTableName = getKvsDynamoTableNameFromConfig(keyValueStoreName, qpqConfig, 'kvs');
        const region = qpqConfigAwsUtils.getApplicationModuleDeployRegion(qpqConfig);
        const result = await getAllItems(dynamoTableName, region);
        return actionResult(result);
    };
};
export const getKeyValueStoreGetAllActionProcessor = async (qpqConfig) => ({
    [KeyValueStoreActionType.GetAll]: getProcessKeyValueStoreGetAll(qpqConfig),
});
