import { qpqConfigAwsUtils } from 'quidproquo-config-aws';
import { actionResult, KeyValueStoreActionType } from 'quidproquo-core';
import { getKvsDynamoTableNameFromConfig } from '../../../awsNamingUtils';
import { scan } from '../../../logic/dynamo/scan';
const getProcessKeyValueStoreScan = (qpqConfig) => {
    return async ({ keyValueStoreName, filterCondition, nextPageKey }) => {
        const dynamoTableName = getKvsDynamoTableNameFromConfig(keyValueStoreName, qpqConfig, 'kvs');
        const region = qpqConfigAwsUtils.getApplicationModuleDeployRegion(qpqConfig);
        const items = await scan(dynamoTableName, region, filterCondition, nextPageKey);
        return actionResult(items);
    };
};
export const getKeyValueStoreScanActionProcessor = async (qpqConfig) => ({
    [KeyValueStoreActionType.Scan]: getProcessKeyValueStoreScan(qpqConfig),
});
