import { qpqConfigAwsUtils } from 'quidproquo-config-aws';
import { actionResult, UserDirectoryActionType, } from 'quidproquo-core';
import { changePassword } from '../../../logic/cognito/changePassword';
const getProcessChangePassword = (qpqConfig) => {
    return async ({ oldPassword, newPassword }, session) => {
        const region = qpqConfigAwsUtils.getApplicationModuleDeployRegion(qpqConfig);
        await changePassword(session.accessToken, oldPassword, newPassword, region);
        return actionResult(void 0);
    };
};
export const getUserDirectoryChangePasswordActionProcessor = async (qpqConfig) => ({
    [UserDirectoryActionType.ChangePassword]: getProcessChangePassword(qpqConfig),
});
