import { qpqConfigAwsUtils } from 'quidproquo-config-aws';
import { actionResult, UserDirectoryActionType, } from 'quidproquo-core';
import { verifyUserEmail } from '../../../logic/cognito/verifyUserEmail';
const getProcessConfirmEmailVerification = (qpqConfig) => {
    return async ({ code, accessToken }) => {
        const region = qpqConfigAwsUtils.getApplicationModuleDeployRegion(qpqConfig);
        await verifyUserEmail(region, accessToken, code);
        return actionResult(void 0);
    };
};
export const getUserDirectoryConfirmEmailVerificationActionProcessor = async (qpqConfig) => ({
    [UserDirectoryActionType.ConfirmEmailVerification]: getProcessConfirmEmailVerification(qpqConfig),
});
