import { qpqConfigAwsUtils } from 'quidproquo-config-aws';
import { actionResult, UserDirectoryActionType, } from 'quidproquo-core';
import { getCFExportNameUserPoolClientIdFromConfig, getCFExportNameUserPoolIdFromConfig } from '../../../awsNamingUtils';
import { getExportedValue } from '../../../logic/cloudformation/getExportedValue';
import { createUser } from '../../../logic/cognito/createUser';
const getProcessCreateUser = (qpqConfig) => {
    return async (payload) => {
        const region = qpqConfigAwsUtils.getApplicationModuleDeployRegion(qpqConfig);
        const userPoolId = await getExportedValue(getCFExportNameUserPoolIdFromConfig(payload.userDirectoryName, qpqConfig), region);
        const userPoolClientId = await getExportedValue(getCFExportNameUserPoolClientIdFromConfig(payload.userDirectoryName, qpqConfig), region);
        const authResponse = await createUser(userPoolId, qpqConfigAwsUtils.getApplicationModuleDeployRegion(qpqConfig), userPoolClientId, payload.createUserRequest);
        return actionResult(authResponse);
    };
};
export const getUserDirectoryCreateUserActionProcessor = async (qpqConfig) => ({
    [UserDirectoryActionType.CreateUser]: getProcessCreateUser(qpqConfig),
});
