import { qpqConfigAwsUtils } from 'quidproquo-config-aws';
import { actionResult, UserDirectoryActionType, } from 'quidproquo-core';
import { getCFExportNameUserPoolClientIdFromConfig, getCFExportNameUserPoolIdFromConfig } from '../../../awsNamingUtils';
import { getExportedValue } from '../../../logic/cloudformation/getExportedValue';
import { forgotPassword } from '../../../logic/cognito/forgotPassword';
const getProcessForgotPassword = (qpqConfig) => {
    return async ({ username, userDirectoryName }) => {
        const region = qpqConfigAwsUtils.getApplicationModuleDeployRegion(qpqConfig);
        const userPoolId = await getExportedValue(getCFExportNameUserPoolIdFromConfig(userDirectoryName, qpqConfig), region);
        const userPoolClientId = await getExportedValue(getCFExportNameUserPoolClientIdFromConfig(userDirectoryName, qpqConfig), region);
        const authResponse = await forgotPassword(userPoolId, userPoolClientId, qpqConfigAwsUtils.getApplicationModuleDeployRegion(qpqConfig), username);
        return actionResult(authResponse);
    };
};
export const getUserDirectoryForgotPasswordActionProcessor = async (qpqConfig) => ({
    [UserDirectoryActionType.ForgotPassword]: getProcessForgotPassword(qpqConfig),
});
