import { qpqConfigAwsUtils } from 'quidproquo-config-aws';
import { actionResult, UserDirectoryActionType, } from 'quidproquo-core';
import { getCFExportNameUserPoolIdFromConfig } from '../../../awsNamingUtils';
import { getExportedValue } from '../../../logic/cloudformation/getExportedValue';
import { getUserAttributesBySub } from '../../../logic/cognito/getUserAttributesBySub';
const getProcessGetUserAttributesByUserId = (qpqConfig) => {
    return async ({ userDirectoryName, userId }, session) => {
        const region = qpqConfigAwsUtils.getApplicationModuleDeployRegion(qpqConfig);
        const userPoolId = await getExportedValue(getCFExportNameUserPoolIdFromConfig(userDirectoryName, qpqConfig), region);
        const userAttributes = await getUserAttributesBySub(userPoolId, region, userId);
        return actionResult(userAttributes);
    };
};
export const getUserDirectoryGetUserAttributesByUserIdActionProcessor = async (qpqConfig) => ({
    [UserDirectoryActionType.GetUserAttributesByUserId]: getProcessGetUserAttributesByUserId(qpqConfig),
});
