import { actionResult, UserDirectoryActionType, } from 'quidproquo-core';
import { decodeAccessToken } from '../../../logic/cognito';
const getProcessSetAccessToken = (qpqConfig) => {
    return async ({ accessToken, userDirectoryName }, session, apl, logger, updateSession) => {
        const decodedAccessToken = await decodeAccessToken(userDirectoryName, qpqConfig, accessToken, false);
        updateSession({
            decodedAccessToken: decodedAccessToken,
            accessToken,
        });
        return actionResult(decodedAccessToken);
    };
};
export const getUserDirectorySetAccessTokenActionProcessor = async (qpqConfig) => ({
    [UserDirectoryActionType.SetAccessToken]: getProcessSetAccessToken(qpqConfig),
});
