import { getCoreActionProcessor as getNodeCoreActionProcessor, getWebserverActionProcessor as getNodeWebserverActionProcessor, } from 'quidproquo-actionprocessor-node';
import { getCoreActionProcessor as getAwsCoreActionProcessor } from './core';
import { getWebserverActionProcessor as getAwsWebserverActionProcessor } from './webserver';
export const getAwsActionProcessors = async (qpqConfig, dynamicModuleLoader) => {
    const storyActionProcessor = {
        ...(await getNodeCoreActionProcessor(qpqConfig, dynamicModuleLoader)),
        ...(await getNodeWebserverActionProcessor(qpqConfig, dynamicModuleLoader)),
        ...(await getAwsCoreActionProcessor(qpqConfig, dynamicModuleLoader)),
        ...(await getAwsWebserverActionProcessor(qpqConfig, dynamicModuleLoader)),
    };
    return storyActionProcessor;
};
export * from './core';
export * from './webserver';
