import { CognitoIdentityProviderClient, DescribeUserPoolClientCommand, } from '@aws-sdk/client-cognito-identity-provider';
import { createAwsClient } from '../createAwsClient';
export const getUserPoolClientSecret = async (userPoolId, clientId, region) => {
    const cognitoClient = createAwsClient(CognitoIdentityProviderClient, {
        region,
    });
    const params = {
        ClientId: clientId,
        UserPoolId: userPoolId,
    };
    const response = await cognitoClient.send(new DescribeUserPoolClientCommand(params));
    if (!response.UserPoolClient?.ClientSecret) {
        throw new Error('Can not find client secret for Cognito user pool client');
    }
    return response.UserPoolClient?.ClientSecret;
};
