import { AdminUpdateUserAttributesCommand, CognitoIdentityProviderClient } from '@aws-sdk/client-cognito-identity-provider';
import { createAwsClient } from '../createAwsClient';
import { getCognitoUserAttributesFromQpqUserAttributes } from './cognitoAttributeMap';
export const setUserAttributes = async (userPoolId, region, username, userAttributes) => {
    const cognitoClient = createAwsClient(CognitoIdentityProviderClient, {
        region,
    });
    const { userId, ...writeableUserAttributes } = userAttributes;
    const params = {
        UserPoolId: userPoolId,
        Username: username,
        UserAttributes: getCognitoUserAttributesFromQpqUserAttributes(writeableUserAttributes),
    };
    await cognitoClient.send(new AdminUpdateUserAttributesCommand(params));
};
