import { DeleteItemCommand, DynamoDBClient } from '@aws-sdk/client-dynamodb';
import { createAwsClient } from '../createAwsClient';
import { buildAttributeValue } from './qpqDynamoOrm';
export async function deleteItem(tableName, region, key, keyName, sortKey, sortKeyName) {
    const dynamoDBClient = createAwsClient(DynamoDBClient, { region });
    const deleteItemParams = {
        TableName: tableName,
        Key: {
            [keyName]: buildAttributeValue(key),
        },
    };
    if (sortKey && sortKeyName) {
        deleteItemParams.Key[sortKeyName] = buildAttributeValue(sortKey);
    }
    await dynamoDBClient.send(new DeleteItemCommand(deleteItemParams));
}
