import { DynamoDBClient, GetItemCommand } from '@aws-sdk/client-dynamodb';
import { createAwsClient } from '../createAwsClient';
export async function getItem(tableName, key, region) {
    const dynamoDBClient = createAwsClient(DynamoDBClient, { region });
    const getItemParams = {
        TableName: tableName,
        Key: {
            key: {
                S: key,
            },
        },
    };
    try {
        const result = await dynamoDBClient.send(new GetItemCommand(getItemParams));
        return result.Item ? JSON.parse(result.Item.value.S) : null;
    }
    catch (error) {
        console.error('Error getting item from DynamoDB:', error);
        throw error;
    }
}
