import { ParameterType, PutParameterCommand, SSMClient } from '@aws-sdk/client-ssm';
import { createAwsClient } from '../createAwsClient';
export const setParameter = async (parameterName, region, value) => {
    const ssmClient = createAwsClient(SSMClient, { region });
    await ssmClient.send(new PutParameterCommand({
        Name: parameterName,
        Value: value,
        Overwrite: true,
        Type: ParameterType.STRING,
    }));
};
