import { PutObjectCommand, S3Client } from '@aws-sdk/client-s3';
import { createAwsClient } from '../createAwsClient';
export const writeBinaryFile = async (bucketName, key, data, region, storageClass) => {
    const s3Client = createAwsClient(S3Client, { region });
    await s3Client.send(new PutObjectCommand({
        Key: key,
        Bucket: bucketName,
        Body: Buffer.from(data.base64Data, 'base64'),
        ContentType: data.mimetype,
        ContentDisposition: data.contentDisposition,
        StorageClass: storageClass,
    }));
};
